︠ba90b5b6-7b34-4995-b124-3fbd7de02a10︠
Author: Vincent J. Matsko
Date: 13 March 2016, Day031
Post: Number Searches
︡bf70699f-22d8-47da-bc53-21a552874a7d︡
︠a3ede9b1-0f58-4378-90f7-d0a4fc534bb7︠
︡e1eac448-8104-4701-bf80-51e8a40684c8︡
︠ddd8b8b4-c774-49ee-ac79-7e7b28920ff1︠
# Recursive pair of functions to find prime factors (including repetitions).
# test is the factor to check.
# If n is divisible by test, try again!  It may be a repeated prime factor.
# Otherwise, recurse with the current n (which keeps getting smaller as more factors are found),
# but increment test to test + 1.
# Don't use for numbers too large - the recursive depth will be exceeded!
def primefactorsaux(n, factorlist, test):
    if n == 1:
        return factorlist
    elif n % test == 0:
        factorlist.append(test);
        return primefactorsaux(n/test, factorlist, test)
    else:
        return primefactorsaux (n, factorlist, test + 1)
    
def primefactors(n):
    return primefactorsaux(n, [], 2)
︡d567e929-7634-4189-aa67-33a137c53ca3︡︡{"done":true}
︠93da3a5a-9587-455d-b385-6b76f90e28e8s︠
primefactors(123456)
︡4c93a998-f798-4646-b5a9-72afe96f5615︡︡{"stdout":"[2, 2, 2, 2, 2, 2, 3, 643]\n","done":false}︡{"done":true}
︠ae86e287-cdaf-4f52-9215-95d9a8d18949s︠
# Iterative version.
# Note the similarity to the recursive version.
# test becomes testfactor here, and is a local variable (rather than an argument to a function).
def factorize (n):
    factorlist = [];
    testfactor = 2;
    currentn = n;
    done = False;
    while not done:
        if currentn == 1:
            done = True
        elif currentn % testfactor == 0:
            factorlist.append(testfactor)
            currentn = currentn / testfactor
        else:
            testfactor += 1
    return factorlist
︡654e840f-b536-4f8a-8367-c5555e6aeb12︡︡{"done":true}
︠fdc0164a-000a-47c9-82d0-1901469b7d45s︠
factorize(123456789)
︡6fed3507-3e18-4568-bd99-bda17306a727︡︡{"stdout":"[3, 3, 3607, 3803]\n","done":false}︡{"done":true}
︠e758f1c8-93d1-405f-a239-7b75135cae53s︠
# This is helpful in solving Number Search puzzles!
def tobase(n,b):
    result = ""
    place = floor(log(n,b))              # Highest power of b less than n.
    nleft = n                            # Keeps track of what we still need to convert.
    while place >= 0:
        digit = floor(nleft / b^place)   # Leading digit of what's left.
        result = result + str(digit)     # Adds this digit to the number (as a string). 
        nleft = nleft - digit * b^place  # Finds what's left to convert.
        place = place - 1                # Moves one place to the right.
    return result
︡8772fda5-b54e-4d7c-b8f4-1030751767c5︡︡{"done":true}
︠1a76f4e6-5940-4823-9cec-24f9e1a22149s︠
tobase(1024,3)
︡ca1437ee-42cf-479e-8b44-ae858f48cfbc︡︡{"stdout":"'1101221'\n","done":false}︡{"done":true}
︠13186fbc-7d45-46f1-84c4-67b1a60bbf5a︠









